/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Linja Zax extension for Mozilla Firefox.
 *
 * The Initial Developer of the Original Code is
 * LINJA DESIGN OY.
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Linja Zax Team <LinjaZax@linjadesign.fi>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
const c_defaultZoomPercent = 100;
const c_guidanceUrl = "http://www.linjadesign.fi/linjazax";
const c_iconPath = "chrome://LinjaZaxController/skin/img/";
const c_enableIconFile = "enable.png";
const c_disableIconFile = "disable.png";
const c_maxAngleCount = 4;
var l_zoomStep = 6; // percent
var l_rotationAngleThreshold = 2; // degrees
var l_enterZoomModeAngleLimit = 95; // degrees 
var l_mouseMoveThreshold = 4; // pixels 
var l_prevX, l_prevY, l_prevPanX, l_prevPanY,l_prevAlpha, l_alpha0, l_totalAlpha, l_zoomMode = false;
var l_zoomPercent = c_defaultZoomPercent; //default zoom percent
var l_prevScreenX,l_prevScreenY,l_left = 0,l_top = 0;
var l_moveVertically = false,l_moveHorizontally  = false,l_vScrollActive = false,l_hScrollActive = false;
var l_scrollByY = 0,l_scrollByX = 0,l_previousZoomFactor = 1,l_previousScrollHeight,l_previousScrollWidth ,l_fractionY = 0,l_fractionX = 0;
var l_prevDeltaAlphaArray = new Array();
var l_prevDeltaAlphaCount;
var l_moveThresoldCount = 0;
const zaxPrefListener = {
  domain: "LinjaZaxController.",
  observe: function(subject, topic, prefName) 
  {
    if (topic != "nsPref:changed") return;
    zaxInit();
  }
}
var l_zaxPrefService = Components.classes["@mozilla.org/preferences-service;1"]
                     .getService(Components.interfaces.nsIPrefService);
var l_zaxPrefRoot = l_zaxPrefService.getBranch(null);
var l_zaxPref = l_zaxPrefService.getBranch("LinjaZaxController.");
var l_zaxPbi = l_zaxPrefRoot.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
l_zaxPbi.addObserver(zaxPrefListener.domain, zaxPrefListener, false);
function zaxInit() 
{
  const unixRe = new RegExp("unix|linux|sun|freebsd", "i");
  try 
  {
    l_zoomStep= l_zaxPref.getIntPref("zoomStep");	
  }
  catch(err) 
  {
    l_zaxPref.setIntPref("zoomStep", 6); return; 
  }
  try
  {
    l_rotationAngleThreshold= l_zaxPref.getIntPref("rotationAngle");
  }
  catch(err)
  {
    l_zaxPref.setIntPref("rotationAngle", 2); return; 
  }
  try
  {
    l_enterZoomModeAngleLimit= l_zaxPref.getIntPref("zoomAngle");
  }
  catch(err)
  {
    l_zaxPref.setIntPref("zoomAngle", 95); return; 
  }
  try
  {
    l_mouseMoveThreshold= l_zaxPref.getIntPref("mouseThreshold");
  }
  catch(err)
  {
    l_zaxPref.setIntPref("mouseThreshold", 4); return; 
  }
}
var disableDragAndDrop = function(aEvent) 
{
  var document = aEvent.originalTarget;
  document.addEventListener("draggesture", function(aEvent){aEvent.preventDefault()},true); 
  document.body.style.MozUserSelect = "none";
  document.body.style.overflow = "hidden";
  l_zoomPercent = 100;
  getBrowser().mCurrentBrowser.markupDocumentViewer.fullZoom = 1;
}
function initilize() 
{
  createToolbarButton();
  var zaxEnable = isZaxEnable(true);
  if (zaxEnable)
  {
    document.getElementById('zax_toolbaritem_enable_disable').setAttribute("image", c_iconPath + c_disableIconFile); 
    document.getElementById('zax_toolbaritem_enable_disable').setAttribute("label", "Disable"); 
    document.getElementById('zax-button').setAttribute("class", "zax-button-enable"); 
    window.addEventListener("mousedown", handleMouseDown, true);
    var applicationContent = window.document.getElementById("appcontent");
    applicationContent.addEventListener("DOMContentLoaded", disableDragAndDrop, false);
    gBrowser.reloadAllTabs(getBrowser().contentDocument);
    try
    {
      pref.setBoolPref("zaxEnable", true);
    }
    catch(error)
    {
    }
  }
  else
  {
    setEnableDisableAttribute();
  }
}
function setEnableDisableAttribute()
{
   document.getElementById('zax_toolbaritem_enable_disable').setAttribute("image", c_iconPath + c_enableIconFile); 
   document.getElementById('zax-button').setAttribute("class", "zax-button-disable");
   document.getElementById('zax_toolbaritem_enable_disable').setAttribute("label", "Enable");
   window.removeEventListener("dblclick", handleMouseDblClick, true); 
}
function deInitilize()
{
  var zaxEnable = isZaxEnable(false);
  if (!zaxEnable)
  {
    setEnableDisableAttribute();
    window.removeEventListener("mousedown", handleMouseDown, true);
    var applicationContent = window.document.getElementById("appcontent");
    applicationContent.removeEventListener("DOMContentLoaded", disableDragAndDrop, false);
    var doc = getBrowser().contentDocument;
    doc.body.style.MozUserSelect = "";
    doc.body.style.overflow = "";
    gBrowser.reloadAllTabs(doc);
    try
    {
      pref.setBoolPref("zaxEnable", false);
    }
    catch(error)
    {
    }
  }
  enableDefaultClickEvent();
}
function enableDefaultClickEvent()
{
  document.onclick = null;
}
function isZaxEnable(defaultValue)
{
  var pref = Components.classes["@mozilla.org/preferences-service;1"]
             .getService(Components.interfaces.nsIPrefBranch);
  var zaxEnable;
  try
  {
    zaxEnable = pref.getBoolPref("zaxEnable");
  }
  catch(e)
  {
    pref.setBoolPref("zaxEnable", defaultValue);
    zaxEnable = defaultValue;
  }
  return zaxEnable;
}
function createToolbarButton()
{
  var toolbox = document.getElementById("navigator-toolbox");
  var toolboxDocument = toolbox.ownerDocument;
  var hasButton = false;
  var i;
  for (i = 0; i < toolbox.childNodes.length; ++i) 
  {
    var toolbar = toolbox.childNodes[i];
    if (toolbar.localName == "toolbar" && toolbar.getAttribute("customizable") == "true") 
    {		
      if (toolbar.currentSet.indexOf("zax-button")>-1)
	hasButton = true;	
    }
  }
  if (!hasButton)
  {
    for (i = 0; i < toolbox.childNodes.length; ++i)
    {
      toolbar = toolbox.childNodes[i];
      if (toolbar.localName == "toolbar" &&  toolbar.getAttribute("customizable") == "true" && toolbar.id == "nav-bar") 
      {
        var newButton = "";
    	  var child = toolbar.firstChild;
    	  while(child)
        {
    	    if (!hasButton && child.id == "urlbar-container")
          {
    		newButton += "zax-button,";
    	      hasButton = true;
    	    }
     	    newButton += child.id+",";
    	    child = child.nextSibling;
    	  }
    	  newButton = newButton.substring(0, newButton.length-1);
    	  toolbar.currentSet = newButton;
    	  toolbar.setAttribute("currentset", newButton);
    	  toolboxDocument.persist(toolbar.id, "currentset");
    	  BrowserToolboxCustomizeDone(true)
    	  break; 
    	}
    }
  }
}
function toggleEnableDisable()
{
  var pref = Components.classes["@mozilla.org/preferences-service;1"]
            .getService(Components.interfaces.nsIPrefBranch);
  var zaxEnable;
  try
  {
    zaxEnable = pref.getBoolPref("zaxEnable");
  }
  catch(e)
  {
    pref.setBoolPref("zaxEnable", true);
    zaxEnable = true;
  }
  if (zaxEnable)
  {
    pref.setBoolPref("zaxEnable", false);
    deInitilize();
  }
  else
  {
    pref.setBoolPref("zaxEnable", true);
    initilize();
  }
}
function openGuidancePage()
{
  getBrowser().selectedTab = gBrowser.addTab(c_guidanceUrl);
}
function zoomFullPage(aEvent,aZoomPercent)
{
  var zoomFactor = l_zoomPercent / c_defaultZoomPercent;
  ZoomManager.zoom = zoomFactor;
  FullZoom._applySettingToPref();
  adjustPerfectly(zoomFactor);
  l_previousZoomFactor = zoomFactor;
}
function handleMouseDblClick(aEvent) 
{
  l_zoomPercent = c_defaultZoomPercent;
  zoomFullPage(aEvent,l_zoomPercent);
}
function isClickOutsideClientArea(aEvent)
{
  var box = gBrowser.mCurrentBrowser.boxObject;
  if (aEvent.screenX < (box.screenX) || aEvent.screenY < (box.screenY) ||
		 		aEvent.screenY > (box.screenY+box.height) ||
				 aEvent.screenX > (box.screenX+box.width))
  {
    return true;
  }
  return false;
}
function doAlignment(aEvent)
{
  var docElement = getBrowser().contentDocument.documentElement;
  var docBody = getBrowser().contentDocument.body;
  var scrollTop = docElement.scrollTop;  
  var scrollLeft = docElement.scrollLeft;
  var scrollWidth = docElement.scrollWidth;
  var scrollHeight = docElement.scrollHeight;
  var clientWidth = docElement.clientWidth;
  var clientHeight = docElement.clientHeight; 
  if( scrollHeight == docElement.clientHeight)
  {	
    scrollTop = docBody.scrollTop; 
    scrollLeft = docBody.scrollLeft;
    scrollWidth = docBody.scrollWidth;
    scrollHeight = docBody.scrollHeight;
    clientWidth = docBody.clientWidth;
    clientHeight = docBody.clientHeight;
  }
  l_previousScrollHeight = scrollHeight ;
  l_previousScrollWidth = scrollWidth ;
  adjustVertically(aEvent,scrollTop,clientHeight,scrollHeight);
  adjustHorizontally(aEvent,scrollLeft,clientWidth,scrollWidth);
  doPageMoving();
  doScrolling(); 
  return true;
}
function doPageMoving()
{
  if (l_moveHorizontally  || l_moveVertically)
  {  
    getBrowser().mCurrentBrowser.markupDocumentViewer.move(l_left,l_top);
    l_moveVertically = false;
    l_moveHorizontally = false;
  }
}
function adjustVertically(aEvent,scrollTop,clientHeight,scrollHeight) 
{
  var y = aEvent.screenY;
  var aEventClientY = aEvent.clientY;
  var scrollBottom = scrollHeight - scrollTop - clientHeight;   
  if( ((((l_prevPanY - aEventClientY) <= scrollBottom ) && (l_prevScreenY > y) ) || (((aEventClientY-l_prevPanY ) <= scrollTop) && (l_prevScreenY < y) )) && scrollTop != 0 && scrollBottom != 0 && l_top == 0) 
  {    
    l_vScrollActive = true;
    l_scrollByY = l_prevPanY - aEventClientY;
  }
  else if((l_prevScreenY < y) && (scrollTop > 0 ) && ((aEventClientY - l_prevPanY) > scrollTop) && l_top == 0)
  {
    l_moveVertically = true;
    l_vScrollActive = true;
    l_scrollByY = -scrollTop;
    l_top =  Math.floor((y - l_prevScreenY)-(scrollTop/l_previousZoomFactor ));
    l_fractionTop += (l_top - Math.floor(l_top )); 
    if(l_fractionTop >= 1)
    {
      l_fractionTop = l_fractionTop  -1;
      l_top ++;
    }
  } 
  else if((l_prevPanY > aEventClientY) && (scrollBottom  > 0 ) && ((l_prevPanY - aEventClientY) > scrollBottom ) && l_top == 0)
  {
    l_moveVertically = true;
    l_vScrollActive = true;
    l_scrollByY = scrollBottom ;
    l_top = Math.round((l_prevScreenY - y)- (scrollBottom/l_previousZoomFactor  ));
  } 
  else if(((l_prevScreenY < y)&& (scrollTop == 0)) || ((l_prevScreenY > y)  && (scrollBottom == 0) ) || ((l_prevScreenY > y)   && (scrollTop == 0) &&  (l_top >= (l_prevScreenY - y))) || ((l_prevScreenY < y)  && (scrollBottom  == 0)  && ((l_top + (y - l_prevScreenY))<= 0)) )
  {
    l_moveVertically = true;
    l_top = l_top + (y-l_prevScreenY);
  } 
  else if( (l_prevScreenY > y) && (scrollTop == 0) && ((l_prevScreenY - y) > l_top ) && (l_top > 0 ) )
  {
    l_moveVertically = true;
    l_vScrollActive = true;   
    l_scrollByY = Math.floor(((l_prevScreenY - y) - l_top) *(l_previousZoomFactor )); 
    l_fractionY +=   (((l_prevScreenY - y) - l_top) *(l_previousZoomFactor )-l_scrollByY); 
    if( l_fractionY >= 1 )
    {
      l_scrollByY ++;
	l_fractionY =  ( l_fractionY - 1);
    }  
    l_top = 0;
  } 
  else if( (l_prevScreenY < y) && (scrollBottom  == 0) && (( y - l_prevScreenY ) > (l_top*(-1)) ) && (l_top < 0))
  {
    l_moveVertically = true;
    l_vScrollActive = true;
    l_scrollByY = -Math.floor(((y-l_prevScreenY) - l_top*(-1)) *(l_previousZoomFactor )); 
    l_fractionY += (-((y-l_prevScreenY) - l_top*(-1)) *(l_previousZoomFactor )- l_scrollByY );
    if(l_fractionY <= -1)
    {
      l_scrollByY--;
    	l_fractionY =  ( l_fractionY + 1);
    }
    l_top = 0;
  }
  else if(((scrollTop == 0) && (l_top == 0) && ( scrollBottom >= (l_prevPanY - aEventClientY)) && (l_prevScreenY > y)) || ((scrollBottom == 0) && (l_top == 0) && ( scrollTop >= (aEventClientY - l_prevPanY)) && (l_prevScreenY < y)))
  {
    l_vScrollActive = true;
    l_scrollByY = l_prevPanY - aEventClientY;   
  }
  else if( (scrollTop == 0) && (scrollBottom == 0) )
  { 
    l_moveVertically = true;
    l_top = l_top + (y-l_prevScreenY);
  }
  else if( (scrollBottom > 0 ) && ( l_top < 0) )
  {
    l_moveVertically = true;
    l_vScrollActive = true;
    l_top = l_top + (y-l_prevScreenY);
    l_scrollByY = scrollBottom ;   
  }
}
function adjustHorizontally(aEvent,scrollLeft,clientWidth,scrollWidth)
{
  var x = aEvent.screenX;
  var aEventClientX = aEvent.clientX;
  var scrollRight =  scrollWidth-scrollLeft-clientWidth;
  if( ((((l_prevPanX - aEventClientX) <= scrollRight ) && (l_prevScreenX > x) ) || (((aEventClientX-l_prevPanX ) <= scrollLeft) && (l_prevScreenX < x) )) && scrollLeft != 0 && scrollRight != 0 && l_left == 0) 
  {  
    l_hScrollActive = true;
    l_scrollByX = l_prevPanX - aEventClientX;
  }
  else if((l_prevPanX < aEventClientX) && (scrollLeft > 0 ) && ((aEventClientX - l_prevPanX) > scrollLeft) && l_left == 0)
  {
    l_moveHorizontally = true;
    l_hScrollActive = true;
    l_scrollByX = -scrollLeft;
    l_left = l_left + (x - l_prevScreenX)-scrollLeft;
  } 
  else if((l_prevPanX > aEventClientX) && (scrollRight  > 0 ) && ((l_prevPanX - aEventClientX) > scrollRight ) && l_left == 0)
  {
    l_moveHorizontally = true;
    l_hScrollActive = true;
    l_scrollByX = scrollRight ;
    l_left = l_left - ((l_prevScreenX - x)- scrollRight );
  }
  else if(((l_prevScreenX < x)&& (scrollLeft == 0)) || ((l_prevScreenX > x)  && (scrollRight == 0) ) || ((l_prevScreenX > x)   && (scrollLeft == 0) &&  (l_left >= (l_prevScreenX - x))) || ((l_prevScreenX < x)  && (scrollRight  == 0)  && ((l_left + (x - l_prevScreenX))<= 0)) )
  {
    l_moveHorizontally = true;
    l_left = l_left + (x-l_prevScreenX);
  } 
  else if( (l_prevScreenX > x) && (scrollLeft == 0) && ((l_prevScreenX - x) > l_left ) && (l_left > 0 ) )
  {
    l_moveHorizontally = true;
    l_hScrollActive = true;      
    l_scrollByX = Math.floor(((l_prevScreenX - x) - l_left) *(l_previousZoomFactor )); 
    l_fractionX +=   (((l_prevScreenX - x) - l_left) *(l_previousZoomFactor )-l_scrollByX); 
    if( l_fractionX >= 1 )
    {
      l_scrollByX ++;
	l_fractionX =  ( l_fractionX - 1);
    }
    l_left = 0;
  } 
  else if( (l_prevScreenX < x) && (scrollRight  == 0) && (( x - l_prevScreenX ) > (l_left*(-1)) ) && (l_left < 0))
  {
    l_moveHorizontally = true;
    l_hScrollActive = true;
    l_scrollByX = -Math.ceil(((x-l_prevScreenX) - l_left*(-1)) *(l_previousZoomFactor )); 
    l_fractionX += (-((x-l_prevScreenX) - l_left*(-1)) *(l_previousZoomFactor )- l_scrollByX );
    if(l_fractionX <= -1)
    {
      l_scrollByX--;
    	l_fractionX =  ( l_fractionX + 1);
    }
    l_left = 0;
  } 
  else if(((scrollLeft == 0) && (l_left == 0) && ( scrollRight >= (l_prevPanX - aEventClientX)) && (l_prevScreenX > x)) || ((scrollRight == 0) && (l_left == 0) && ( scrollLeft >= (aEventClientX - l_prevPanX)) && (l_prevScreenX < x)))
  {
    l_hScrollActive = true;
    l_scrollByX = l_prevPanX - aEventClientX     
  }
  else if( (scrollLeft == 0) && (scrollRight == 0) )
  {
    l_moveHorizontally = true;
    l_left = l_left + (x-l_prevScreenX);
  } 
  else if( (scrollRight > 0 ) && ( l_left < 0) )
  {
    l_moveHorizontally = true;
    l_hScrollActive = true;
    l_left = l_left + (x-l_prevScreenX);
    l_scrollByX = scrollRight ;    
  }
}
function adjustPerfectly(zoomFactor)
{
  var docElement = getBrowser().contentDocument.documentElement;
  var docBody = getBrowser().contentDocument.body;
  var scrollTop = docElement.scrollTop;  
  var scrollLeft = docElement.scrollLeft;
  var scrollWidth = docElement.scrollWidth;
  var scrollHeight = docElement.scrollHeight;
  var clientWidth = docElement.clientWidth;
  var clientHeight = docElement.clientHeight; 
  if( scrollHeight == docElement.clientHeight)
  {	
    scrollTop = docBody.scrollTop; 
    scrollLeft = docBody.scrollLeft;
    scrollWidth = docBody.scrollWidth;
    scrollHeight = docBody.scrollHeight;
    clientWidth = docBody.clientWidth;
    clientHeight = docBody.clientHeight;
  }
  var scrollBottom = scrollHeight - scrollTop - clientHeight; 
  var scrollRight =  scrollWidth-scrollLeft-clientWidth;
  if( (l_top < 0) && (scrollBottom > 0) )
  {  
    l_vScrollActive = true;
    l_moveVertically = true;
    l_scrollByY = scrollBottom ;
    l_top = Math.round(l_top + (scrollBottom /zoomFactor )); 
    if( l_top > 0)
    {
      l_scrollByY = -(l_top*zoomFactor );
      l_top = 0;
    }   
  }
  else if((l_top > 0) && (scrollTop > 0) )
  { 
    l_moveVertically = true;
    l_vScrollActive = true;
    l_scrollByY = (l_top*zoomFactor );
    l_top = 0;
  }
  if( (l_left < 0) && (scrollRight > 0) )
  { 
    l_hScrollActive = true;
    l_moveHorizontally = true;
    l_scrollByX = scrollRight ;
    l_left = Math.round(l_left + (scrollRight /zoomFactor));
    if( l_left > 0)
    {
      l_scrollByX = -(l_left*zoomFactor )
      l_left = 0;
    }
  }
  else if((l_left > 0) && (scrollLeft > 0) )
  { 
    l_hScrollActive = true;
    l_moveHorizontally = true;
    l_scrollByX = (l_left*zoomFactor );
    l_left = 0;
  }
  doPageMoving();
  doScrolling(); 
}
function dummyEventHandler(aEvent)
{
  return false;
}
function doScrolling()
{
  if (l_vScrollActive && l_hScrollActive)
  {
    window.content.scrollBy(l_scrollByX, l_scrollByY);
  }
  else
  {
    if (l_hScrollActive)
    {
      window.content.scrollBy(l_scrollByX, 0);
    }
    if (l_vScrollActive)
    {
      window.content.scrollBy(0, l_scrollByY);
    }
  }
  l_scrollByX = 0;
  l_scrollByY = 0; 
  l_vScrollActive = false;
  l_hScrollActive = false;
  return true;
}
function handleMouseDown(aEvent) 
{
  if (isClickOutsideClientArea(aEvent)) 
  {
    return true;
  } 
  enableDefaultClickEvent();
  l_zoomPercent = getBrowser().mCurrentBrowser.markupDocumentViewer.fullZoom*100;
  l_prevScreenX = aEvent.screenX;
  l_prevScreenY = aEvent.screenY;
  l_left = 0;
  l_top  = 0;
  l_prevX = aEvent.screenX;
  l_prevY = aEvent.screenY;
  l_prevPanX = aEvent.clientX;
  l_prevPanY = aEvent.clientY;
  l_alpha0 = -1;
  l_totalAlpha = 0;
  l_zoomMode = false;
  l_scrollByY = 0;
  l_scrollByX = 0;
  l_fractionY = 0;
  l_fractionX = 0; 
  l_prevDeltaAlphaCount = 0;
  l_moveThresoldCount = 0;
  window.addEventListener("mousemove", handleMouseMove, true);
  window.addEventListener("mouseup", handleMouseUp, true);
  window.addEventListener("dblclick", handleMouseDblClick, true);
  return true;
} 
function handleMouseUp(aEvent) 
{
  l_zoomMode = false;
  window.removeEventListener("mousemove", handleMouseMove, true);
  window.removeEventListener("mouseup", handleMouseUp, true);
  getBrowser().mCurrentBrowser.markupDocumentViewer.move(0,0);
  return false;
}
function backupDeltaAlpha(aDeltaAlpha)
{
  var i;
  if(l_prevDeltaAlphaCount < c_maxAngleCount - 1)
  {
      l_prevDeltaAlphaCount++;
  }
  for(i = 0;i < l_prevDeltaAlphaCount - 1;i++)
  {
   l_prevDeltaAlphaArray[i] = l_prevDeltaAlphaArray[i + 1];
  }
  l_prevDeltaAlphaArray[l_prevDeltaAlphaCount - 1] = aDeltaAlpha;
}
function getAngleDirection()
{
  var i;
  var positiveCount = 0,negativeCount = 0;
  for (i = 0;i < l_prevDeltaAlphaCount;i++)
  {
    if(l_prevDeltaAlphaArray[i] < 0)
    {
      negativeCount++;
    }
    else
    {
      positiveCount++;
    }
  }
  if(positiveCount >= c_maxAngleCount - 1)
  {
    return 1;
  }
  else if(negativeCount >= c_maxAngleCount - 1)
  {
    return -1;
  }
  return 0;
}
function assignPreviousPosition(aPosX, aPosY)
{
  l_prevX = aPosX;
  l_prevY = aPosY;
}
function handleMouseMove(aEvent) 
{
   if (isClickOutsideClientArea(aEvent)) 
   {    
     return true;
   }
   var alpha,deltaAlpha,x, y;
   x = aEvent.screenX;
   y = aEvent.screenY;
   var dx,dy;
   dx = Math.abs(x - l_prevScreenX);
   dy = Math.abs(y - l_prevScreenY);
   if(dx > dy)
   {
     l_moveThresoldCount = l_moveThresoldCount + dx;
   }
   else
   {
     l_moveThresoldCount = l_moveThresoldCount + dy;
   }  
   if( l_moveThresoldCount >= 10)
   {
     document.onclick = dummyEventHandler;
   }
   doAlignment(aEvent);  
   l_prevPanX = aEvent.clientX;
   l_prevPanY = aEvent.clientY;
   l_prevScreenX = x;
   l_prevScreenY = y;
   var alphaValue = (Math.atan2(x-l_prevX, y-l_prevY)+Math.PI)/2/Math.PI*360;
   if (Math.sqrt((x-l_prevX)^2 + (y-l_prevY)^2) < l_mouseMoveThreshold)
   {
     return true;
   }
   if (l_alpha0 < 0) 
   {
     l_alpha0 = alphaValue;
     l_prevAlpha = l_alpha0;
     assignPreviousPosition(x,y);
     return true;
   }
   alpha = alphaValue;
   deltaAlpha = alpha-l_prevAlpha;
   if (Math.abs(deltaAlpha) > 180)
   {
     deltaAlpha = (Math.abs(deltaAlpha)-360)*deltaAlpha/Math.abs(deltaAlpha);
   }
   backupDeltaAlpha(deltaAlpha);
   if (Math.abs(deltaAlpha) > 90  && !l_zoomMode)
   {
     assignPreviousPosition(x,y);
     return true;
   }
   if (Math.abs(deltaAlpha) < l_rotationAngleThreshold) 
   {
     assignPreviousPosition(x,y);
     return true;
   }
   l_totalAlpha = l_totalAlpha + deltaAlpha;
   if (Math.abs(l_totalAlpha) > l_enterZoomModeAngleLimit || l_zoomMode) 
   {
     l_zoomMode = true;
     if(getAngleDirection() < 0) 
     {
       l_zoomPercent += l_zoomStep;
       var maxZoomPercent = l_zaxPrefService.getIntPref("zoom.maxPercent");
       if (l_zoomPercent > maxZoomPercent )
       {
         l_zoomPercent =  maxZoomPercent ;
       }
     }
     else if(getAngleDirection() > 0)
     {
       l_zoomPercent -= l_zoomStep;
       var minZoomPercent = l_zaxPrefService.getIntPref("zoom.minPercent");
       if (l_zoomPercent <  minZoomPercent)
       {
         l_zoomPercent =  minZoomPercent;
       }
     }
     zoomFullPage(aEvent,l_zoomPercent);
   }
   assignPreviousPosition(x,y);
   l_prevAlpha = alpha;
   return true;
 }
